"use strict";

var _schemes = require("./schemes");

var _expressionAst = require("./expression-ast");

function _evalExpr(expression) {
  var ex = (0, _expressionAst.prj)(expression);
  return ex instanceof _expressionAst.Plus ? ex.left + ex.right : ex instanceof _expressionAst.Times ? ex.left * ex.right : ex instanceof _expressionAst.Paren ? ex.contents : /* ex is a Num     */ex.value;
}

var evalExpr = function evalExpr(ex) {
  return (0, _schemes.cata)(_evalExpr, ex, _expressionAst.exprFunctor);
};

// AST for 2 * (1 + 1) * 4 * 3
var expr = (0, _expressionAst.times)((0, _expressionAst.num)(2), (0, _expressionAst.times)((0, _expressionAst.paren)((0, _expressionAst.plus)((0, _expressionAst.num)(1), (0, _expressionAst.num)(1))), (0, _expressionAst.times)((0, _expressionAst.num)(4), (0, _expressionAst.num)(3))));
console.log(evalExpr(expr));